;;Coded by Denis Duplan for Stash of Code (http://www.stashofcode.fr, stashofcode@gmail.com) in december 2018.
;;This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
(module
	(memory (import "someImports" "someJSMemory") 1)
	(func $smv (import "someImports" "showMemoryValue") (param i32))
	(func $f (param $min i32) (param $max i32) (param $inc i32)
		(local $count i32)				;;Declare $count as local
		(local $index i32)				;;Declare $index as local
		get_local $min					;;Push $min
		set_local $index				;;Pop $min and store it in $index
		(block
			(loop

				;;Increment next i32 in memory by $inc

				get_local $index		;;Push $index (for i32.store later)
				i32.const 2				;;Push 2
				i32.shl					;;Pop $index and 2, shift $index 2 bits to the left (ie: $index * 4) and push the result
				get_local $index		;;Push $index
				i32.const 2				;;Push 2
				i32.shl					;;Pop $index and 2, shift $index 2 bits to the left (ie: $index * 4) and push the result
				i32.load				;;Pop $index * 4, read i32 in memory at index $index * 4, and push i32
				get_local $inc			;;Push $inc
				i32.add					;;Pop $inc and i32, add $inc to i32 and push the result
				i32.store				;;Pop the result and $index, store the result at index $index * 4 in memory

				;;Display new i32

				get_local $index		;;Push $index
				call $smv				;;Call $smv (which pops $index)
				
				;;Increment $index by 1

				get_local $index		;;Push $index
				i32.const 1				;;Push 1
				i32.add					;;Pop 1 and $index, add 1 to $index and push result
				set_local $index		;;Pop result and store it in $index

				;;Loop if required

				get_local $index		;;Push $index
				get_local $max			;;Push $max
				i32.gt_u				;;Test if $index > $max
				br_if 1					;;Exit loop if yes
				br 0					;;Loop if not
			)
		)
	)
	(export "addToMemoryRange" (func $f))
)